unit Contact;
interface
uses Messages;

type
  TMessage = class;

  TMessage = class
  strict private
    FSubject: String;
    FBody: String;

    procedure SetBody(const Value: String);
    procedure SetSubject(const Value: String);

  public
    property Subject: String read FSubject write SetSubject;

    property Body: String read FBody write SetBody;
  end;

  IContact = interface
    procedure Contact(Msg: TMessage);
  end;

  TPerson = class abstract(TInterfacedObject)
  strict protected
    function GetName : String;virtual;abstract;
    procedure SetName(val : String);virtual;abstract;
  public
    property Name :  String read GetName write SetName;
  end;

  TContact = class abstract(TPerson, IContact)
  public
    property Name :  String read GetName write SetName;

    procedure Contact(Msg: TMessage);virtual;abstract;

  strict protected
    procedure SetName(val : String);override;
    function GetName : String;override;
  end;

  TEmailContact = class(TContact)
  strict private
    FEmailAddress: String;

    procedure SetEmailAddress(const Value: String);

  public
    procedure Contact(Msg:TMessage);override;

    property EmailAddress: String read FEmailAddress write SetEmailAddress;
  end;

  TSkypeContact = class(TContact)
  strict private
    FSkypeHandle: String;

    procedure SetSkypeHandle(const Value: String);

  public
    property SkypeHandle: String read FSkypeHandle write SetSkypeHandle;
  end;

var
  GlobalVar: Integer;

implementation

function TContact.GetName: String;
begin
end;

procedure TContact.SetName(val : String);
begin
end;

{ TMessage }

procedure TMessage.SetBody(const Value: String);
begin
  FBody := Value;
end;

procedure TMessage.SetSubject(const Value: String);
begin
  FSubject := Value;
end;

procedure TEmailContact.Contact(Msg:TMessage);
begin
// TODO
end;

procedure TEmailContact.SetEmailAddress(const Value: String);
begin
  FEmailAddress := Value;
end;

procedure TSkypeContact.SetSkypeHandle(const Value: String);
begin
  FSkypeHandle := Value;
end;

end.
